#!/usr/bin/python3

def generate_map_rules():
	out = open("maps.txt", "w")

	n_tiers = 6
	tier_names = ["same_tier"] + ["tier-{}".format(i) for i in range(1, n_tiers)]
	tiers = [("same_tier", 0), ("tier-2", 2), ("tier-4", 4)]
	rarities = ["Normal", "Magic", "Rare", "Unique"]

	for i, n in enumerate(tier_names):
		out.write('category "map.{}"\n'.format(n))
		out.write('{\n\tclass "Map";\n\tor\n\t{\n')
		out.write("\t\tmax_item_level {};\n".format(68+i))
		for t in range(2, 17):
			out.write("\t\tand\n\t\t{\n")
			out.write("\t\t\tdrop_level {};\n".format(67+t))
			out.write("\t\t\tmax_item_level {};\n".format(67+t+i))
			out.write("\t\t};\n")
		out.write("\t};\n};\n")

	for n in tier_names:
		for r in rarities:
			out.write('category "map.{}.{}"\n'.format(r.lower(), n))
			out.write("{\n")
			out.write('\tcategory "map.{}";\n'.format(n))
			out.write("\trarity {};\n".format(r))
			out.write("};\n")

	for r in rarities:
		out.write('category "map.{}.any"\n'.format(r.lower()))
		out.write('{\n\tclass "Map";\n')
		out.write("\trarity {};\n".format(r))
		out.write("};\n")

def main():
	generate_map_rules()

if __name__=="__main__":
	main()
